Index: src/southbridge/sis/sis966/sis966_early_smbus.c
===================================================================
--- src/southbridge/sis/sis966/sis966_early_smbus.c	(revision 2923)
+++ src/southbridge/sis/sis966/sis966_early_smbus.c	(working copy)
@@ -134,7 +134,7 @@
 };


-#if 1
+
 uint8_t	SiS_NB_init[56][3]={
 {0x04, 0x00 ,0x07},					//Reg 0x04
 {0x05, 0x00 ,0x00},					//Reg 0x05 // alex
@@ -191,85 +191,11 @@
 {0x97, 0x00 ,0x00},					//Reg 0x97
 {0x98, 0x00 ,0x00},					//Reg 0x98
 {0x99, 0x00 ,0x00},					//Reg 0x99
-// alex
-//{0xD7, 0x00 ,0x00},					//Reg 0x99
-//{0xDD, 0x00 ,0x02},					//Reg 0x99
-//
-//{0x13, 0x00 ,0xF0},					//Reg 0x99

 {0x00, 0x00, 0x00}					//End of table
 };

-#else
-uint8_t	SiS_NB_init[61][3]={
-{0x04, 0x00 ,0x07},					//Reg 0x04
-{0x05, 0x00 ,0x00},					//Reg 0x05 // alex
-{0x0D, 0x00 ,0x20},					//Reg 0x0D
-{0x2C, 0x00 ,0x39},					//Reg 0x2C
-{0x2D, 0x00 ,0x10},					//Reg 0x2D
-{0x2E, 0x00 ,0x61},					//Reg 0x2E
-{0x2F, 0x00 ,0x07},					//Reg 0x2F
-{0x34, 0x00 ,0xA0},					//Reg 0x34
-{0x40, 0x00 ,0x36},					//Reg 0x40
-{0x42, 0x00 ,0xB9},					//Reg 0x42
-{0x43, 0x00 ,0x8B},					//Reg 0x43
-{0x44, 0x00 ,0x05},					//Reg 0x44
-{0x45, 0x00 ,0xFF},					//Reg 0x45
-{0x46, 0x00 ,0x90},					//Reg 0x46
-{0x47, 0x00 ,0xA0},					//Reg 0x47
-{0x4C, 0xFF ,0x50},					//Reg 0x4C //  SiS307 enable
-{0x4E, 0x00 ,0x00},					//Reg 0x4E
-{0x4F, 0x00 ,0x02},					//Reg 0x4F
-{0x5B, 0x00 ,0x44},					//Reg 0x5B
-{0x5D, 0x00 ,0x00},					//Reg 0x5D
-{0x5E, 0x00 ,0x25},					//Reg 0x5E
-{0x61, 0x00 ,0xB0},					//Reg 0x61
-{0x65, 0x00 ,0xB0},					//Reg 0x65
-{0x68, 0x00 ,0x4C},					//Reg 0x68
-{0x69, 0x00 ,0xD0},					//Reg 0x69
-{0x6B, 0x00 ,0x07},					//Reg 0x6B
-{0x6C, 0x00 ,0xDD},					//Reg 0x6C
-{0x6D, 0x00 ,0xAD},					//Reg 0x6D
-{0x6E, 0x00 ,0xE8},					//Reg 0x6E
-{0x6F, 0x00 ,0x4D},					//Reg 0x6F
-{0x70, 0x00 ,0x00},					//Reg 0x70
-{0x71, 0x00 ,0x80},					//Reg 0x71
-{0x72, 0x00 ,0x00},					//Reg 0x72
-{0x73, 0x00 ,0x00},					//Reg 0x73
-{0x74, 0x00 ,0x01},					//Reg 0x74
-{0x75, 0x00 ,0x10},					//Reg 0x75
-{0x7E, 0x00 ,0x29},					//Reg 0x7E
-{0x8B, 0x00 ,0x10},					//Reg 0x8B
-{0x8D, 0x00 ,0x03},					//Reg 0x8D
-{0xA1, 0x00 ,0xD0},					//Reg 0xA1
-{0xA2, 0x00 ,0x30},					//Reg 0xA2
-{0xA4, 0x00 ,0x0B},					//Reg 0xA4
-{0xA9, 0x00 ,0x02},					//Reg 0xA9
-{0xB0, 0x00 ,0x30},					//Reg 0xB0
-{0xB4, 0x00 ,0x30},					//Reg 0xB4
-{0x90, 0x00 ,0x00},					//Reg 0x90
-{0x91, 0x00 ,0x00},					//Reg 0x91
-{0x92, 0x00 ,0x00},					//Reg 0x92
-{0x93, 0x00 ,0x00},					//Reg 0x93
-{0x94, 0x00 ,0x00},					//Reg 0x94
-{0x95, 0x00 ,0x00},					//Reg 0x95
-{0x96, 0x00 ,0x00},					//Reg 0x96
-{0x97, 0x00 ,0x00},					//Reg 0x97
-{0x98, 0x00 ,0x00},					//Reg 0x98
-{0x99, 0x00 ,0x00},					//Reg 0x99
-// alex
-{0x86, 0x00 ,0x14},					//Reg 0x99
-{0x87, 0x00 ,0xC8},					//Reg 0x99
-{0xF4, 0x00 ,0x01},
-//
-{0x13, 0x00 ,0xF0},					//Reg 0x99

-{0x00, 0x00, 0x00}					//End of table
-};
-
-
-#endif
-#if 1
 uint8_t SiS_NBAGP_init[34][3]={
 {0xCF, 0xDF, 0x00},      //HT issue
 {0x06, 0xDF, 0x20},
@@ -309,78 +235,6 @@
 {0x00, 0x00, 0x00}     //End of table
 };

-
-
-#else
-
-//uint8_t SiS_NBAGP_init[53][3]={
-uint8_t SiS_NBAGP_init[40][3]={
-{0x04, 0x00 ,0x07},					//Reg 0x04
-{0x05, 0x00 ,0x01},					//Reg 0x05 // alex
-
-{0xCF, 0xDF, 0x00},      //HT issue
-{0x06, 0xDF, 0x20},
-{0x1E, 0xDF, 0x20},
-{0x50, 0x00, 0x02},
-{0x51, 0x00, 0x00},
-{0x54, 0x00, 0x09},
-{0x55, 0x00, 0x00},
-{0x56, 0x00, 0x80},
-{0x58, 0x00, 0x08},
-{0x60, 0x00, 0xB1},
-{0x61, 0x00, 0x02},
-{0x62, 0x00, 0x60},
-{0x63, 0x00, 0x60},
-{0x64, 0x00, 0xAA},
-{0x65, 0x00, 0x18},
-{0x68, 0x00, 0x23},
-{0x69, 0x00, 0x23},
-{0x6A, 0x00, 0xC8},
-{0x6B, 0x00, 0x08},
-{0x6C, 0x00, 0x00},
-{0x6D, 0x00, 0x00},
-{0x6E, 0x00, 0x08},
-{0x6F, 0x00, 0x00},
-{0xBB, 0x00, 0x00},
-{0xB5, 0x00, 0x30},
-{0xB0, 0x00, 0xDB},
-{0xB6, 0x00, 0x73},
-{0xB7, 0x00, 0x50},
-{0xBA, 0xBF, 0x41},
-{0xB4, 0x3F, 0xC0},
-{0xBF, 0xF9, 0x06},
-{0xBA, 0x00, 0x61},
-{0xBD, 0x7F, 0x80},
-
-
-
-{0x0D, 0x00 ,0x40},					//Reg 0x05 // alex
-/*
-{0x19, 0x00 ,0x01},					//Reg 0x05 // alex
-{0x1A, 0x00 ,0x01},					//Reg 0x05 // alex
-{0x1B, 0x00 ,0x40},					//Reg 0x05 // alex
-{0x1C, 0x00 ,0xE0},					//Reg 0x05 // alex
-{0x1D, 0x00 ,0xE0},					//Reg 0x05 // alex
-{0x20, 0x00 ,0xB0},					//Reg 0x05 // alex
-{0x21, 0x00 ,0xFE},					//Reg 0x05 // alex
-{0x22, 0x00 ,0xB0},					//Reg 0x05 // alex
-{0x23, 0x00 ,0xFE},					//Reg 0x05 // alex
-{0x24, 0x00 ,0x00},					//Reg 0x05 // alex
-{0x25, 0x00 ,0xD8},					//Reg 0x05 // alex
-{0x26, 0x00 ,0xF0},					//Reg 0x05 // alex
-{0x27, 0x00 ,0xDF},					//Reg 0x05 // alex
-*/
-{0x3E, 0x00 ,0x0A},					//Reg 0x05 // alex
-
-{0xCB, 0x00 ,0x10},					//Reg 0x05 // alex
-{0xCF, 0x00 ,0x48},					//Reg 0x05 // alex
-
-
-{0x00, 0x00, 0x00}     //End of table
-};
-
-#endif
-
 uint8_t	SiS_ACPI_2_init[56][3]={
 {0x00, 0x00, 0xFF},					//Reg 0x00
 {0x01, 0x00, 0xFF},					//Reg 0x01
@@ -440,129 +294,55 @@
 {0x00, 0x00, 0x00}					//End of table
 };

-#if 0
-uint8_t	SiS_SiS1183_init[60][3]={
-{0x04, 0x00, 0x05},
-{0x09, 0x00, 0x05},
-{0x2C, 0x00, 0x39},
-{0x2D, 0x00, 0x10},
-{0x2E, 0x00, 0x83},
-{0x2F, 0x00, 0x11},
-{0x90, 0x00, 0x40},
-{0x91, 0x00, 0x00},	// set mode
-{0x50, 0x00, 0xA2},
-{0x52, 0x00, 0xA2},
-{0x55, 0x00, 0x96},
-{0x52, 0x00, 0xA2},
-{0x55, 0xF7, 0x00},
-{0x56, 0x00, 0xC0},
-{0x57, 0x00, 0x14},
-{0x67, 0x00, 0x28},
-{0x81, 0x00, 0xB3},
-{0x82, 0x00, 0x72},
-{0x83, 0x00, 0x40},
-{0x85, 0x00, 0xB3},
-{0x86, 0x00, 0x72},
-{0x87, 0x00, 0x40},
-{0x88, 0x00, 0xDE},      // after set mode
-{0x89, 0x00, 0xB3},
-{0x8A, 0x00, 0x72},
-{0x8B, 0x00, 0x40},
-{0x8C, 0x00, 0xDE},
-{0x8D, 0x00, 0xB3},
-{0x8E, 0x00, 0x92},
-{0x8F, 0x00, 0x40},
-{0x93, 0x00, 0x00},
-{0x94, 0x00, 0x80},
-{0x95, 0x00, 0x08},
-{0x96, 0x00, 0x80},
-{0x97, 0x00, 0x08},
-{0x9C, 0x00, 0x80},
-{0x9D, 0x00, 0x08},
-{0x9E, 0x00, 0x80},
-{0x9F, 0x00, 0x08},
-{0xA0, 0x00, 0x15},
-{0xA1, 0x00, 0x15},
-{0xA2, 0x00, 0x15},
-{0xA3, 0x00, 0x15},
-
-//{0xD8, 0xFE, 0x01},	// Com reset
-//{0xC8, 0xFE, 0x01},
-//{0xE8, 0xFE, 0x01},
-//{0xF8, 0xFE, 0x01},
-{0xC4, 0xFF, 0xFF},    // Clear status
-{0xC5, 0xFF, 0xFF},
-{0xC6, 0xFF, 0xFF},
-{0xC7, 0xFF, 0xFF},
-{0xD4, 0xFF, 0xFF},
-{0xD5, 0xFF, 0xFF},
-{0xD6, 0xFF, 0xFF},
-{0xD7, 0xFF, 0xFF},
-{0xE4, 0xFF, 0xFF},    // Clear status
-{0xE5, 0xFF, 0xFF},
-{0xE6, 0xFF, 0xFF},
-{0xE7, 0xFF, 0xFF},
-{0xF4, 0xFF, 0xFF},
-{0xF5, 0xFF, 0xFF},
-{0xF6, 0xFF, 0xFF},
-{0xF7, 0xFF, 0xFF},
-{0x00, 0x00, 0x00}					//End of table
-};
-
-#else
-
 uint8_t	SiS_SiS1183_init[44][3]={
-{0x04, 0x00, 0x05},
-{0x09, 0x00, 0x05},
-{0x2C, 0x00, 0x39},
-{0x2D, 0x00, 0x10},
-{0x2E, 0x00, 0x83},
-{0x2F, 0x00, 0x11},
-{0x90, 0x00, 0x40},
-{0x91, 0x00, 0x00},	// set mode
-{0x50, 0x00, 0xA2},
-{0x52, 0x00, 0xA2},
-{0x55, 0x00, 0x96},
-{0x52, 0x00, 0xA2},
-{0x55, 0xF7, 0x00},
-{0x56, 0x00, 0xC0},
+{0x04, 0x00, 0x05},
+{0x09, 0x00, 0x05},
+{0x2C, 0x00, 0x39},
+{0x2D, 0x00, 0x10},
+{0x2E, 0x00, 0x83},
+{0x2F, 0x00, 0x11},
+{0x90, 0x00, 0x40},
+{0x91, 0x00, 0x00},	// set mode
+{0x50, 0x00, 0xA2},
+{0x52, 0x00, 0xA2},
+{0x55, 0x00, 0x96},
+{0x52, 0x00, 0xA2},
+{0x55, 0xF7, 0x00},
+{0x56, 0x00, 0xC0},
 {0x57, 0x00, 0x14},
-{0x67, 0x00, 0x28},
-{0x81, 0x00, 0xB3},
-{0x82, 0x00, 0x72},
-{0x83, 0x00, 0x40},
-{0x85, 0x00, 0xB3},
-{0x86, 0x00, 0x72},
+{0x67, 0x00, 0x28},
+{0x81, 0x00, 0xB3},
+{0x82, 0x00, 0x72},
+{0x83, 0x00, 0x40},
+{0x85, 0x00, 0xB3},
+{0x86, 0x00, 0x72},
 {0x87, 0x00, 0x40},
-{0x88, 0x00, 0xDE},      // after set mode
-{0x89, 0x00, 0xB3},
-{0x8A, 0x00, 0x72},
-{0x8B, 0x00, 0x40},
-{0x8C, 0x00, 0xDE},
-{0x8D, 0x00, 0xB3},
-{0x8E, 0x00, 0x92},
-{0x8F, 0x00, 0x40},
-{0x93, 0x00, 0x00},
-{0x94, 0x00, 0x80},
-{0x95, 0x00, 0x08},
-{0x96, 0x00, 0x80},
+{0x88, 0x00, 0xDE},      // after set mode
+{0x89, 0x00, 0xB3},
+{0x8A, 0x00, 0x72},
+{0x8B, 0x00, 0x40},
+{0x8C, 0x00, 0xDE},
+{0x8D, 0x00, 0xB3},
+{0x8E, 0x00, 0x92},
+{0x8F, 0x00, 0x40},
+{0x93, 0x00, 0x00},
+{0x94, 0x00, 0x80},
+{0x95, 0x00, 0x08},
+{0x96, 0x00, 0x80},
 {0x97, 0x00, 0x08},
-{0x9C, 0x00, 0x80},
-{0x9D, 0x00, 0x08},
-{0x9E, 0x00, 0x80},
-{0x9F, 0x00, 0x08},
-{0xA0, 0x00, 0x15},
-{0xA1, 0x00, 0x15},
-{0xA2, 0x00, 0x15},
+{0x9C, 0x00, 0x80},
+{0x9D, 0x00, 0x08},
+{0x9E, 0x00, 0x80},
+{0x9F, 0x00, 0x08},
+{0xA0, 0x00, 0x15},
+{0xA1, 0x00, 0x15},
+{0xA2, 0x00, 0x15},
 {0xA3, 0x00, 0x15},
-
-
 {0x00, 0x00, 0x00}					//End of table
 };

-#endif

-/*       In => Share Memory size
+/*       In => Share Memory size
                             => 00h :    0MBytes
                             => 02h :   32MBytes
                             => 03h :   64MBytes
@@ -570,14 +350,14 @@
                             => Others:  Reserved
 */
 void Init_Share_Memory(uint8_t ShareSize)
-{
+{
     device_t dev;
-
+
     dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, PCI_DEVICE_ID_SIS_SIS761), 0);
     pci_write_config8(dev, 0x4C, (pci_read_config8(dev, 0x4C) & 0x1F) | (ShareSize << 5));
 }
-
-/* In:     => Aperture size
+
+/* In:     => Aperture size
                => 00h :   32MBytes
                => 01h :   64MBytes
                => 02h :  128MBytes
@@ -587,77 +367,24 @@
 */
 void Init_Aper_Size(uint8_t AperSize)
 {
- device_t dev;
- uint16_t SiSAperSizeTable[]={0x0F38, 0x0F30, 0x0F20, 0x0F00, 0x0E00};
-
- dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_AMD, 0x1103), 0);
- pci_write_config8(dev, 0x90, AperSize << 1);
+        device_t dev;
+        uint16_t SiSAperSizeTable[]={0x0F38, 0x0F30, 0x0F20, 0x0F00, 0x0E00};

-//pci_write_config32(dev, 0x94, 0x78);
-//pci_write_config32(dev, 0x98, 0x0);
-
-#if 0
-{
-int i;
-print_debug("Function3 Config in sis_init_stage2\n");
-for(i=0;i<0xFF;i+=4)
-{   if((i%16)==0)
-    {print_debug("\r\n");print_debug_hex8(i);print_debug("  ");}
-    print_debug_hex32(pci_read_config32(dev,i));
-    print_debug("  ");
-}
-print_debug("\n");
-}
-#endif
+        dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_AMD, 0x1103), 0);
+        pci_write_config8(dev, 0x90, AperSize << 1);

-dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, PCI_DEVICE_ID_SIS_SIS761), 0);
-pci_write_config16(dev, 0xB4, SiSAperSizeTable[AperSize]);
-
-#if 0
-{
-int i;
-dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_AMD, 0x1101), 0);
-print_debug("Function1 Config in sis_init_stage2\n");
-for(i=0;i<0xFF;i+=4)
-{    if((i%16)==0)
-    {print_debug("\r\n");print_debug_hex8(i);print_debug("  ");}
-    print_debug_hex32(pci_read_config32(dev,i));
-    print_debug("  ");
+        dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, PCI_DEVICE_ID_SIS_SIS761), 0);
+        pci_write_config16(dev, 0xB4, SiSAperSizeTable[AperSize]);
 }
-print_debug("\n");
-}

- #endif
-
-
-}
-
-
-
-
-
 void sis_init_stage1(void)
 {
-  device_t dev;
-	uint8_t temp8;
-  int	i;
-	uint8_t	GUI_En;
+        device_t dev;
+        uint8_t temp8;
+        int	i;
+        uint8_t	GUI_En;

-#if 0
-{
-int i;
-print_debug("Northbridge PCI Config in sis_init_stage1.0\n");
-for(i=0;i<0xFF;i+=4)
-{    if((i%16)==0)
-    {print_debug("\r\n");print_debug_hex8(i);print_debug("  ");}
-    print_debug_hex32(pci_read_config32(dev,i));
-    print_debug("  ");
-}
-print_debug("\n");
-}
-#endif
-
-// SiS_Chipset_Initialization
+// SiS_Chipset_Initialization
 // ========================== NB =============================
 	dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, PCI_DEVICE_ID_SIS_SIS761), 0);
 	i=0;
@@ -669,23 +396,6 @@
 					i++;
 	};

-
-#if 0
-{
-int i;
-print_debug("Northbridge PCI Config in sis_init_stage1.1\n");
-for(i=0;i<0xFF;i+=4)
-{    if((i%16)==0)
-    {print_debug("\r\n");print_debug_hex8(i);print_debug("  ");}
-    print_debug_hex32(pci_read_config32(dev,i));
-    print_debug("  ");
-}
-print_debug("\n");
-}
-#endif
-
-
-
 // ========================== LPC =============================
 	dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, PCI_DEVICE_ID_SIS_SIS966_LPC), 0);
 	i=0;
@@ -723,16 +433,16 @@
 	dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, PCI_DEVICE_ID_SIS_SIS761), 0);		//Restore Internal GUI enable bit
 	temp8 = pci_read_config8(dev, 0x4C);
 	pci_write_config8(dev, 0x4C, temp8 | GUI_En);
-
-     return;
+
+     return;
 }



 void sis_init_stage2(void)
 {
-  	device_t dev;
-  	msr_t	msr;
+  	device_t dev;
+  	msr_t	msr;
 	int	i;
 	uint32_t j;
 	uint8_t temp8;
@@ -740,90 +450,57 @@


 // ========================== NB_AGP =============================
- dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, PCI_DEVICE_ID_SIS_SIS761), 0);   //Enable Internal GUI enable bit
- pci_write_config8(dev, 0x4C, pci_read_config8(dev, 0x4C) | 0x10);
-
- dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, 0x0002), 0);
- i=0;
- while(SiS_NBAGP_init[i][0] != 0)
- {    temp8 = pci_read_config8(dev, SiS_NBAGP_init[i][0]);
-     temp8 &= SiS_NBAGP_init[i][1];
-     temp8 |= SiS_NBAGP_init[i][2];
-     pci_write_config8(dev, SiS_NBAGP_init[i][0], temp8);
-     i++;
- };
+        dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, PCI_DEVICE_ID_SIS_SIS761), 0);   //Enable Internal GUI enable bit
+        pci_write_config8(dev, 0x4C, pci_read_config8(dev, 0x4C) | 0x10);

-/*       In => Share Memory size
-                            => 00h :    0MBytes
-                            => 02h :   32MBytes
-                            => 03h :   64MBytes
-                            => 04h :  128MBytes
-                            => Others:  Reserved
-*/
-/* In:     => Aperture size
-               => 00h :   32MBytes
-               => 01h :   64MBytes
-               => 02h :  128MBytes
-               => 03h :  256MBytes
-               => 04h :  512MBytes
-               => Others:  Reserved
-*/
-
-  Init_Share_Memory(0x02);  //0x02 : 32M  0x03 : 64M
-  Init_Aper_Size(0x01);   // 0x1
+        dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, PCI_DEVICE_ID_SIS_AGP), 0);
+        i=0;

-#if 0
-{
-int i;
-print_debug("AGP PCI Config in sis_init_stage2\n");
-for(i=0;i<0xFF;i+=4)
-{    if((i%16)==0)
-    {print_debug("\r\n");print_debug_hex8(i);print_debug("  ");}
-    print_debug_hex32(pci_read_config32(dev,i));
-    print_debug("  ");
-}
-print_debug("\n");
-}
-#endif
+        while(SiS_NBAGP_init[i][0] != 0)
+        {
+                temp8 = pci_read_config8(dev, SiS_NBAGP_init[i][0]);
+                temp8 &= SiS_NBAGP_init[i][1];
+                temp8 |= SiS_NBAGP_init[i][2];
+                pci_write_config8(dev, SiS_NBAGP_init[i][0], temp8);
+                i++;
+        };

+/**
+  *   Share Memory size
+  *             => 00h :    0MBytes
+  *             => 02h :   32MBytes
+  *             => 03h :   64MBytes
+  *             => 04h :  128MBytes
+  *             => Others:  Reserved
+  *
+  *   Aperture size
+  *             => 00h :   32MBytes
+  *             => 01h :   64MBytes
+  *             => 02h :  128MBytes
+  *             => 03h :  256MBytes
+  *             => 04h :  512MBytes
+  *             => Others:  Reserved
+  */

+        Init_Share_Memory(0x02);  //0x02 : 32M
+        Init_Aper_Size(0x01);   //0x1 : 64M
+
 // ========================== NB =============================

-	printk_debug("Init NorthBridge sis761 -------->\n");
-	dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, PCI_DEVICE_ID_SIS_SIS761), 0);
-	msr = rdmsr(0xC001001A);
-	printk_debug("Memory Top Bound %lx\n",msr.lo );
-// 	pci_write_config16(dev, 0x8E, msr.lo >> 16);				// Topbound
-//    pci_write_config16(dev, 0x8E, (msr.lo >> 16) - ((pci_read_config8(dev, 0x4C) & 0xE0) >> 5));
-
-    temp16=(pci_read_config8(dev, 0x4C) & 0xE0) >> 5;
-    //printk_debug("0x4c = %x\n",temp16);
-    temp16=0x0001<<(temp16-1);
-    temp16<<=8;
-
-    printk_debug("Integrated VGA Shared memory size=%dM bytes\n", temp16 >> 4);
-    pci_write_config16(dev, 0x8E, (msr.lo >> 16) -temp16*1);
-  // pci_write_config16(dev, 0x8E, (msr.lo >> 16) -temp16);
-    pci_write_config8(dev, 0x7F, 0x08);									// ACPI Base
-    outb(inb(0x856) | 0x40, 0x856);										// Auto-Reset Function
+        printk_debug("Init NorthBridge sis761 -------->\n");
+        dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, PCI_DEVICE_ID_SIS_SIS761), 0);
+        msr = rdmsr(0xC001001A);
+	 printk_debug("Memory Top Bound %lx\n",msr.lo );

-#if 0
-{
-int i;
-print_debug("Northbridge PCI Config in sis_init_stage2\n");
-for(i=0;i<0xFF;i+=4)
-{    if((i%16)==0)
-    {print_debug("\r\n");print_debug_hex8(i);print_debug("  ");}
-    print_debug_hex32(pci_read_config32(dev,i));
-    print_debug("  ");
-}
-print_debug("\n");
-}
-#endif
+        temp16=(pci_read_config8(dev, 0x4C) & 0xE0) >> 5;
+        temp16=0x0001<<(temp16-1);
+        temp16<<=8;

+        printk_debug("Integrated VGA Shared memory size=%dM bytes\n", temp16 >> 4);
+        pci_write_config16(dev, 0x8E, (msr.lo >> 16) -temp16*1);
+        pci_write_config8(dev, 0x7F, 0x08);									// ACPI Base
+        outb(inb(0x856) | 0x40, 0x856);										// Auto-Reset Function

-
-
 // ========================== ACPI =============================
 	i=0;
 	printk_debug("Init ACPI -------->\n");
@@ -839,57 +516,40 @@
        printk_debug("Init Misc -------->\n");
 	dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, PCI_DEVICE_ID_SIS_SIS966_ISA), 0);
 	// PCI Device Enable
-	pci_write_config8(dev, 0x7C, 0x03);  // bit0=0 : enable audio controller(), bit1=1 : disable modem
+	pci_write_config8(dev, 0x7C, 0x03);  // bit0=0 : enable audio controller(), bit1=1 : disable modem
 	pci_write_config8(dev, 0x76, pci_read_config8(dev, 0x76)|0x30);  // SM bus enable, PCIEXP Controller 1 and 2 disable
-	pci_write_config8(dev, 0x7E, 0x00);  // azalia controller enable
+	pci_write_config8(dev, 0x7E, 0x00);  // azalia controller enable

 	temp8=inb(0x878)|0x4;   //bit2=1 enable Azalia  =0 enable AC97
 	outb(temp8, 0x878);  // ACPI select AC97 or HDA controller
 	printk_debug("Audio select %x\n",inb(0x878));
-
-	dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, 0x1183), 0);
-	if(!dev){
+
+	dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, PCI_DEVICE_ID_SIS_SIS966_SATA0), 0);
+	if(!dev){
 		print_debug("SiS 1183 does not exist !!");
 	}
 	// SATA Set Mode
 	pci_write_config8(dev, 0x90, (pci_read_config8(dev, 0x90)&0x3F) | 0x40);
-

-//-------------- enable IDE (SiS1183) -------------------------
-/*
-{
-       uint8_t  temp8;
-       int i=0;
-	while(SiS_SiS1183_init[i][0] != 0)
-	{				temp8 = pci_read_config8(dev, SiS_SiS1183_init[i][0]);
-					temp8 &= SiS_SiS1183_init[i][1];
-					temp8 |= SiS_SiS1183_init[i][2];
-					pci_write_config8(dev, SiS_SiS1183_init[i][0], temp8);
-					i++;
-	};
 }

-*/

-}

-
-
 static void enable_smbus(void)
 {
 	device_t dev;
 	uint8_t temp8;
 	printk_debug("enable_smbus -------->\n");
-
+
 	dev = pci_locate_device(PCI_ID(PCI_VENDOR_ID_SIS, PCI_DEVICE_ID_SIS_SIS966_LPC), 0);

 	/* set smbus iobase && enable ACPI Space*/
-	pci_write_config16(dev, 0x74, 0x0800);			// Set ACPI Base
+	pci_write_config16(dev, 0x74, 0x0800);				// Set ACPI Base
 	temp8=pci_read_config8(dev, 0x40);					// Enable ACPI Space
 	pci_write_config8(dev, 0x40, temp8 | 0x80);
 	temp8=pci_read_config8(dev, 0x76);					// Enable SMBUS
 	pci_write_config8(dev, 0x76, temp8 | 0x03);
-
+
 	printk_debug("enable_smbus <--------\n");
 }

Index: src/southbridge/sis/sis966/sis966_ide.c
===================================================================
--- src/southbridge/sis/sis966/sis966_ide.c	(revision 2923)
+++ src/southbridge/sis/sis966/sis966_ide.c	(working copy)
@@ -32,44 +32,44 @@
 #include "sis966.h"

 uint8_t	SiS_SiS5513_init[49][3]={
-{0x04, 0xFF, 0x05},
-{0x0D, 0xFF, 0x80},
-{0x2C, 0xFF, 0x39},
-{0x2D, 0xFF, 0x10},
-{0x2E, 0xFF, 0x13},
-{0x2F, 0xFF, 0x55},
-{0x50, 0xFF, 0xA2},
-{0x51, 0xFF, 0x21},
-{0x53, 0xFF, 0x21},
-{0x54, 0xFF, 0x2A},
-{0x55, 0xFF, 0x96},
-{0x52, 0xFF, 0xA2},
-{0x56, 0xFF, 0x81},
-{0x57, 0xFF, 0xC0},
-{0x60, 0xFF, 0xFB},
-{0x61, 0xFF, 0xAA},
-{0x62, 0xFF, 0xFB},
-{0x63, 0xFF, 0xAA},
-{0x81, 0xFF, 0xB3},
-{0x82, 0xFF, 0x72},
-{0x83, 0xFF, 0x40},
-{0x85, 0xFF, 0xB3},
-{0x86, 0xFF, 0x72},
-{0x87, 0xFF, 0x40},
-{0x94, 0xFF, 0xC0},
-{0x95, 0xFF, 0x08},
-{0x96, 0xFF, 0xC0},
-{0x97, 0xFF, 0x08},
-{0x98, 0xFF, 0xCC},
-{0x99, 0xFF, 0x04},
-{0x9A, 0xFF, 0x0C},
-{0x9B, 0xFF, 0x14},
-{0xA0, 0xFF, 0x11},
-{0x57, 0xFF, 0xD0},
+{0x04, 0xFF, 0x05},
+{0x0D, 0xFF, 0x80},
+{0x2C, 0xFF, 0x39},
+{0x2D, 0xFF, 0x10},
+{0x2E, 0xFF, 0x13},
+{0x2F, 0xFF, 0x55},
+{0x50, 0xFF, 0xA2},
+{0x51, 0xFF, 0x21},
+{0x53, 0xFF, 0x21},
+{0x54, 0xFF, 0x2A},
+{0x55, 0xFF, 0x96},
+{0x52, 0xFF, 0xA2},
+{0x56, 0xFF, 0x81},
+{0x57, 0xFF, 0xC0},
+{0x60, 0xFF, 0xFB},
+{0x61, 0xFF, 0xAA},
+{0x62, 0xFF, 0xFB},
+{0x63, 0xFF, 0xAA},
+{0x81, 0xFF, 0xB3},
+{0x82, 0xFF, 0x72},
+{0x83, 0xFF, 0x40},
+{0x85, 0xFF, 0xB3},
+{0x86, 0xFF, 0x72},
+{0x87, 0xFF, 0x40},
+{0x94, 0xFF, 0xC0},
+{0x95, 0xFF, 0x08},
+{0x96, 0xFF, 0xC0},
+{0x97, 0xFF, 0x08},
+{0x98, 0xFF, 0xCC},
+{0x99, 0xFF, 0x04},
+{0x9A, 0xFF, 0x0C},
+{0x9B, 0xFF, 0x14},
+{0xA0, 0xFF, 0x11},
+{0x57, 0xFF, 0xD0},

-{0xD8, 0xFE, 0x01},	// Com reset
-{0xC8, 0xFE, 0x01},
-{0xC4, 0xFF, 0xFF},    // Clear status
+{0xD8, 0xFE, 0x01},    // Com reset
+{0xC8, 0xFE, 0x01},
+{0xC4, 0xFF, 0xFF},    // Clear status
 {0xC5, 0xFF, 0xFF},
 {0xC6, 0xFF, 0xFF},
 {0xC7, 0xFF, 0xFF},
@@ -78,10 +78,10 @@
 {0xD6, 0xFF, 0xFF},
 {0xD7, 0xFF, 0xFF},

-
-{0x2C, 0xFF, 0x39},	// set subsystem ID
-{0x2D, 0xFF, 0x10},
-{0x2E, 0xFF, 0x13},
+
+{0x2C, 0xFF, 0x39},	// set subsystem ID
+{0x2D, 0xFF, 0x10},
+{0x2E, 0xFF, 0x13},
 {0x2F, 0xFF, 0x55},


@@ -96,22 +96,23 @@
 	uint16_t word;
 	uint8_t byte;
 	conf = dev->chip_info;
-
-

-printk_debug("ide_init:---------->\n");


+print_debug("IDE_INIT:---------->\n");
+
+
 //-------------- enable IDE (SiS5513) -------------------------
 {
-       uint8_t  temp8;
-       int i=0;
+        uint8_t  temp8;
+        int i=0;
 	while(SiS_SiS5513_init[i][0] != 0)
-	{				temp8 = pci_read_config8(dev, SiS_SiS5513_init[i][0]);
-					temp8 &= SiS_SiS5513_init[i][1];
-					temp8 |= SiS_SiS5513_init[i][2];
-					pci_write_config8(dev, SiS_SiS5513_init[i][0], temp8);
-					i++;
+	{
+                temp8 = pci_read_config8(dev, SiS_SiS5513_init[i][0]);
+                temp8 &= SiS_SiS5513_init[i][1];
+                temp8 |= SiS_SiS5513_init[i][2];
+                pci_write_config8(dev, SiS_SiS5513_init[i][0], temp8);
+                i++;
 	};
 }
 //-----------------------------------------------------------
@@ -146,7 +147,27 @@
 	pci_dev_init(dev);
 #endif

+#if DEBUG_IDE
+{
+        int i;
+
+        print_debug("****** IDE PCI config ******");
+        print_debug("\n    03020100  07060504  0B0A0908  0F0E0D0C");
+
+        for(i=0;i<0xff;i+=4){
+                if((i%16)==0){
+                        print_debug("\r\n");
+                        print_debug_hex8(i);
+                        print_debug(": ");
+                }
+                print_debug_hex32(pci_read_config32(dev,i));
+                print_debug("  ");
+        }
+        print_debug("\r\n");
 }
+#endif
+print_debug("IDE_INIT:<----------\n");
+}

 static void lpci_set_subsystem(device_t dev, unsigned vendor, unsigned device)
 {
Index: src/southbridge/sis/sis966/sis966_lpc.c
===================================================================
--- src/southbridge/sis/sis966/sis966_lpc.c	(revision 2923)
+++ src/southbridge/sis/sis966/sis966_lpc.c	(working copy)
@@ -151,81 +151,33 @@
 	lpc_common_init(dev);
 }

-#if 0
-static void enable_hpet(struct device *dev)
-{
-	unsigned long hpet_address;

-	pci_write_config32(dev,0x44, 0xfed00001);
-	hpet_address=pci_read_config32(dev,0x44)& 0xfffffffe;
-	printk_debug("enabling HPET @0x%x\n", hpet_address);
-}
-#endif
-
 static void lpc_usb_legacy_init(device_t dev)
 {
     uint16_t acpi_base;

     acpi_base = (pci_read_config8(dev,0x75) << 8);
-    //printk_debug("ACPI Base Addr=0x%4.4x\n",acpi_base);

-    //printk_debug("acpi_base + 0xbb=%.2x\n", inb(acpi_base + 0xbb));
-    //printk_debug("acpi_base + 0xba=%.2x\n", inb(acpi_base + 0xba));
-
     outb(inb(acpi_base + 0xbb) |0x80, acpi_base + 0xbb);
     outb(inb(acpi_base + 0xba) |0x80, acpi_base + 0xba);
-
-    //printk_debug("acpi_base + 0xbb=%.2x\n", inb(acpi_base + 0xbb));
-    //printk_debug("acpi_base + 0xba=%.2x\n", inb(acpi_base + 0xba));
-
-    return;
 }

 static void lpc_init(device_t dev)
 {
-	uint8_t byte;
-	uint8_t byte_old;
-	int on;
-	int nmi_option;
+	 uint8_t byte;
+	 uint8_t byte_old;
+	 int on;
+	 int nmi_option;

-        printk_debug("lpc_init -------->\n");
+        printk_debug("LPC_INIT -------->\n");
         init_pc_keyboard(0x60, 0x64, 0);

-#if 0
-            {
-            int i;
-            printk_debug("LPC PCI config \n");
-            for(i=0;i<0xFF;i+=4)
-            {
-              if((i%16)==0)
-              {
-                print_debug("\r\n");
-                print_debug_hex8(i);
-                print_debug("  ");}
-                print_debug_hex32(pci_read_config32(dev,i));
-                print_debug("  ");
-              }
-              print_debug("\r\n");
-            }
-#endif
-            printk_debug("lpc_init <--------\n");
-            lpc_usb_legacy_init(dev);
-            return;
-
-       printk_debug("lpc_init\r\n");
-	lpc_common_init(dev);
-       printk_debug("lpc_init2\r\n");
+        lpc_usb_legacy_init(dev);
+	 lpc_common_init(dev);

-
-#if 0
-	/* posted memory write enable */
-	byte = pci_read_config8(dev, 0x46);
-	pci_write_config8(dev, 0x46, byte | (1<<0));
-
-#endif
 	/* power after power fail */

-#if 1
+
 	on = MAINBOARD_POWER_ON_AFTER_POWER_FAIL;
 	get_option(&on, "power_on_after_fail");
 	byte = pci_read_config8(dev, PREVIOUS_POWER_STATE);
@@ -235,7 +187,7 @@
 	}
 	pci_write_config8(dev, PREVIOUS_POWER_STATE, byte);
 	printk_info("set power %s after power fail\n", on?"on":"off");
-#endif
+
 	/* Throttle the CPU speed down for testing */
 	on = SLOW_CPU_OFF;
 	get_option(&on, "slow_cpu");
@@ -249,44 +201,34 @@
 		printk_debug("Throttling CPU %2d.%1.1d percent.\n",
 				(on*12)+(on>>1),(on&1)*5);
 	}
-
-#if 0
-// default is enabled
-	/* Enable Port 92 fast reset */
-	byte = pci_read_config8(dev, 0xe8);
-	byte |= ~(1 << 3);
-	pci_write_config8(dev, 0xe8, byte);
-#endif

-	/* Enable Error reporting */
-	/* Set up sync flood detected */
-	byte = pci_read_config8(dev, 0x47);
-	byte |= (1 << 1);
-	pci_write_config8(dev, 0x47, byte);
+        /* Enable Error reporting */
+        /* Set up sync flood detected */
+        byte = pci_read_config8(dev, 0x47);
+        byte |= (1 << 1);
+        pci_write_config8(dev, 0x47, byte);

-	/* Set up NMI on errors */
-	byte = inb(0x70); // RTC70
-	byte_old = byte;
-	nmi_option = NMI_OFF;
-	get_option(&nmi_option, "nmi");
-	if (nmi_option) {
-		byte &= ~(1 << 7); /* set NMI */
-	} else {
-		byte |= ( 1 << 7); // Can not mask NMI from PCI-E and NMI_NOW
-	}
-	if( byte != byte_old) {
-		outb(0x70, byte);
-	}
+        /* Set up NMI on errors */
+        byte = inb(0x70); // RTC70
+        byte_old = byte;
+        nmi_option = NMI_OFF;
+        get_option(&nmi_option, "nmi");
+        if (nmi_option) {
+                byte &= ~(1 << 7); /* set NMI */
+        } else {
+                byte |= ( 1 << 7); // Can not mask NMI from PCI-E and NMI_NOW
+        }
+        if( byte != byte_old) {
+                outb(0x70, byte);
+        }

-	/* Initialize the real time clock */
-	rtc_init(0);
+        /* Initialize the real time clock */
+        rtc_init(0);

-	/* Initialize isa dma */
-	isa_dma_init();
+        /* Initialize isa dma */
+        isa_dma_init();

-	/* Initialize the High Precision Event Timers */
-//	enable_hpet(dev);
-
+        printk_debug("LPC_INIT <--------\n");
 }

 static void sis966_lpc_read_resources(device_t dev)
@@ -403,38 +345,6 @@
 	.device	= PCI_DEVICE_ID_SIS_SIS966_LPC,
 };

-static const struct pci_driver lpc_driver_pro __pci_driver = {
-	.ops	= &lpc_ops,
-	.vendor	= PCI_VENDOR_ID_SIS,
-	.device	= PCI_DEVICE_ID_SIS_SIS966_PRO,
-};
-
-static const struct pci_driver lpc_driver_lpc2 __pci_driver = {
-	.ops	= &lpc_ops,
-	.vendor	= PCI_VENDOR_ID_SIS,
-	.device	= PCI_DEVICE_ID_SIS_SIS966_LPC_2,
-};
-static const struct pci_driver lpc_driver_lpc3 __pci_driver = {
-	.ops	= &lpc_ops,
-	.vendor	= PCI_VENDOR_ID_SIS,
-	.device	= PCI_DEVICE_ID_SIS_SIS966_LPC_3,
-};
-static const struct pci_driver lpc_driver_lpc4 __pci_driver = {
-	.ops	= &lpc_ops,
-	.vendor	= PCI_VENDOR_ID_SIS,
-	.device	= PCI_DEVICE_ID_SIS_SIS966_LPC_4,
-};
-static const struct pci_driver lpc_driver_lpc5 __pci_driver = {
-	.ops	= &lpc_ops,
-	.vendor	= PCI_VENDOR_ID_SIS,
-	.device	= PCI_DEVICE_ID_SIS_SIS966_LPC_5,
-};
-static const struct pci_driver lpc_driver_lpc6 __pci_driver = {
-	.ops	= &lpc_ops,
-	.vendor	= PCI_VENDOR_ID_SIS,
-	.device	= PCI_DEVICE_ID_SIS_SIS966_LPC_6,
-};
-
 static struct device_operations lpc_slave_ops  = {
 	.read_resources	= sis966_lpc_read_resources,
 	.set_resources	= pci_dev_set_resources,
@@ -443,9 +353,3 @@
 //	.enable		= sis966_enable,
 	.ops_pci	= &lops_pci,
 };
-
-static const struct pci_driver lpc_driver_slave __pci_driver = {
-	.ops	= &lpc_slave_ops,
-	.vendor	= PCI_VENDOR_ID_SIS,
-	.device	= PCI_DEVICE_ID_SIS_SIS966_SLAVE,
-};
